unofficial mirror of libc-alpha@sourceware.org
 help / color / mirror / Atom feed
* [PATCH] ld.so: add an --argv0 option
@ 2020-08-12 11:06 Vincent Mihalkovic via Libc-alpha
  2020-08-25 15:10 ` Adhemerval Zanella via Libc-alpha
  0 siblings, 1 reply; 22+ messages in thread
From: Vincent Mihalkovic via Libc-alpha @ 2020-08-12 11:06 UTC (permalink / raw)
  To: libc-alpha; +Cc: Florian Weimer

[-- Attachment #1: Type: text/plain, Size: 343 bytes --]

Hi,

I have seen that the development branch is open for glibc 2.33.
In reaction to previous e-mail communication with Florian Weimer:

> "I guest we could add --argv0 now (well, after the 2.32 release), and if
> it's incompatible with some applications, we can perhaps tweak it later."
>
I'm sending my argv0 patch again.

vincent mihalkovic

[-- Attachment #2: changelog.txt --]
[-- Type: text/plain, Size: 240 bytes --]

2020-07-22  Vincent Mihalkovic  <vmihalko@redhat.com>

	* elf/Makefile: added argv0 test case, Modified.
	* elf/rtld.c: added --argv0 option, Modified.
	* elf/argv0test.c: test case, New file.
	* elf/tst-rtld-argv0.sh: test case, New file.

[-- Attachment #3: argv0.patch --]
[-- Type: application/x-patch, Size: 4788 bytes --]

^ permalink raw reply	[flat|nested] 22+ messages in thread
* [PATCH] ld.so: add an --argv0 option
@ 2020-07-22  8:33 Vincent Mihalkovic via Libc-alpha
  2020-07-22  9:00 ` Florian Weimer via Libc-alpha
  0 siblings, 1 reply; 22+ messages in thread
From: Vincent Mihalkovic via Libc-alpha @ 2020-07-22  8:33 UTC (permalink / raw)
  To: libc-alpha

[-- Attachment #1: Type: text/plain, Size: 218 bytes --]

Hi,
a few years ago there was an effort for adding --argv0 option:
https://sourceware.org/legacy-ml/libc-alpha/2016-04/msg00576.html.
I made the old patch actual for version 2.31.9000, added a test case and
changelog.

[-- Attachment #2: changelog.txt --]
[-- Type: text/plain, Size: 240 bytes --]

2020-07-22  Vincent Mihalkovic  <vmihalko@redhat.com>

	* elf/Makefile: added argv0 test case, Modified.
	* elf/rtld.c: added --argv0 option, Modified.
	* elf/argv0test.c: test case, New file.
	* elf/tst-rtld-argv0.sh: test case, New file.

[-- Attachment #3: argv0.patch --]
[-- Type: text/x-patch, Size: 4788 bytes --]

diff --git a/elf/Makefile b/elf/Makefile
index 0b78721848..f38904d831 100644
--- a/elf/Makefile
+++ b/elf/Makefile
@@ -210,7 +210,8 @@ tests += restest1 preloadtest loadfail multiload origtest resolvfail \
 	 tst-filterobj tst-filterobj-dlopen tst-auxobj tst-auxobj-dlopen \
 	 tst-audit14 tst-audit15 tst-audit16 \
 	 tst-single_threaded tst-single_threaded-pthread \
-	 tst-tls-ie tst-tls-ie-dlmopen
+	 tst-tls-ie tst-tls-ie-dlmopen \
+	 argv0test
 #	 reldep9
 tests-internal += loadtest unload unload2 circleload1 \
 	 neededtest neededtest2 neededtest3 neededtest4 \
@@ -414,7 +415,7 @@ endif
 ifeq (yes,$(build-shared))
 ifeq ($(run-built-tests),yes)
 tests-special += $(objpfx)tst-pathopt.out $(objpfx)tst-rtld-load-self.out \
-		 $(objpfx)tst-rtld-preload.out
+		 $(objpfx)tst-rtld-preload.out $(objpfx)argv0test.out
 endif
 tests-special += $(objpfx)check-textrel.out $(objpfx)check-execstack.out \
 		 $(objpfx)check-wx-segment.out \
@@ -1796,3 +1797,11 @@ $(objpfx)tst-tls-ie-dlmopen.out: \
   $(objpfx)tst-tls-ie-mod6.so
 
 $(objpfx)tst-tls-surplus: $(libdl)
+
+ARGV0 = test-argv0
+$(objpfx)argv0test.out: tst-rtld-argv0.sh $(objpfx)ld.so \
+			$(objpfx)argv0test
+	$(SHELL) $< $(objpfx)ld.so $(objpfx)argv0test \
+            '$(test-wrapper-env)' '$(run_program_env)' \
+            '$(rpath-link)' '$(ARGV0)' > $@; \
+    $(evaluate-test)
diff --git a/elf/argv0test.c b/elf/argv0test.c
new file mode 100644
index 0000000000..4c79bebf23
--- /dev/null
+++ b/elf/argv0test.c
@@ -0,0 +1,13 @@
+#include <stdio.h>   // for printf
+#include <string.h>  // for strcmp
+
+
+int main( int argc, char *argv[] ) {
+	int result = strcmp( argv[0], "test-argv0");
+ 
+	printf ("argv[0] = %s, strcmp( argv[0], \"test-argv0\" ) = %d, %s\n", \
+					argv[0], result, !result ? "ok" : "wrong");
+
+	return result;
+
+}
diff --git a/elf/rtld.c b/elf/rtld.c
index 5b882163fa..cafa4f9bd3 100644
--- a/elf/rtld.c
+++ b/elf/rtld.c
@@ -1202,6 +1202,8 @@ dl_main (const ElfW(Phdr) *phdr,
 	 installing it.  */
       rtld_is_main = true;
 
+      char *argv0 = NULL;
+
       /* Note the place where the dynamic linker actually came from.  */
       GL(dl_rtld_map).l_name = rtld_progname;
 
@@ -1259,6 +1261,14 @@ dl_main (const ElfW(Phdr) *phdr,
 	else if (! strcmp (_dl_argv[1], "--preload") && _dl_argc > 2)
 	  {
 	    preloadarg = _dl_argv[2];
+	    _dl_skip_args += 2;
+	    _dl_argc -= 2;
+	    _dl_argv += 2;
+	  }
+	else if (! strcmp (_dl_argv[1], "--argv0") && _dl_argc > 2)
+	  {
+	    argv0 = _dl_argv[2];
+
 	    _dl_skip_args += 2;
 	    _dl_argc -= 2;
 	    _dl_argv += 2;
@@ -1292,7 +1302,8 @@ of this helper program; chances are you did not intend to run this program.\n\
   --inhibit-rpath LIST  ignore RUNPATH and RPATH information in object names\n\
 			in LIST\n\
   --audit LIST          use objects named in LIST as auditors\n\
-  --preload LIST        preload objects named in LIST\n");
+  --preload LIST        preload objects named in LIST\n\
+  --argv0 STRING        set argv[0] to STRING before running\n");
 
       ++_dl_skip_args;
       --_dl_argc;
@@ -1384,6 +1395,11 @@ of this helper program; chances are you did not intend to run this program.\n\
 	    break;
 	  }
 #endif
+
+      /* Set the argv[0] string now that we've processed the executable.  */
+      if (argv0 != NULL) {
+		_dl_argv[0] = argv0;
+	  }
     }
   else
     {
diff --git a/elf/tst-rtld-argv0.sh b/elf/tst-rtld-argv0.sh
new file mode 100755
index 0000000000..5f873b6c5c
--- /dev/null
+++ b/elf/tst-rtld-argv0.sh
@@ -0,0 +1,37 @@
+#!/bin/sh
+# Test --argv0 argument ld.so.
+# Copyright (C) 2019-2020 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+#
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2.1 of the License, or (at your option) any later version.
+#
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public
+# License along with the GNU C Library; if not, see
+# <https://www.gnu.org/licenses/>.
+
+set -e
+
+rtld=$1
+test_program=$2
+test_wrapper_env=$3
+run_program_env=$4
+library_path=$5
+argv0=$6
+
+echo "# [${test_wrapper_env}] [${run_program_env}] [$rtld] [--library-path]" \
+     "[$library_path] [--argv0] [$argv0] [$test_program]"
+${test_wrapper_env} \
+${run_program_env} \
+$rtld --library-path "$library_path" \
+  --argv0 "$argv0" $test_program 2>&1 && rc=0 || rc=$?
+echo "# exit status $rc"
+
+exit $rc

^ permalink raw reply related	[flat|nested] 22+ messages in thread
* [PATCH] ld.so: add an --argv0 option
@ 2016-04-23  5:28 Mike Frysinger
  2016-04-23 12:21 ` Florian Weimer
  0 siblings, 1 reply; 22+ messages in thread
From: Mike Frysinger @ 2016-04-23  5:28 UTC (permalink / raw)
  To: libc-alpha; +Cc: shenhan

Sometimes when you run a program you want the argv[0] string passed to
the app to be different than the actual path you used to load it.  We
can't do this today with invoking via ld.so which can be limiting --
some programs like to inspect their argv[0] and make decisions as to
how it should (re)exec itself or helper tools.  For example, clang and
gcc both do argv[0] inspection to support relocatable toolchains.
---
 elf/rtld.c | 17 ++++++++++++++++-
 1 file changed, 16 insertions(+), 1 deletion(-)

diff --git a/elf/rtld.c b/elf/rtld.c
index 647661c..a42b5f6 100644
--- a/elf/rtld.c
+++ b/elf/rtld.c
@@ -796,6 +796,8 @@ dl_main (const ElfW(Phdr) *phdr,
 	 installing it.  */
       rtld_is_main = true;
 
+      char *argv0 = NULL;
+
       /* Note the place where the dynamic linker actually came from.  */
       GL(dl_rtld_map).l_name = rtld_progname;
 
@@ -850,6 +852,14 @@ dl_main (const ElfW(Phdr) *phdr,
 	    _dl_argc -= 2;
 	    _dl_argv += 2;
 	  }
+	else if (! strcmp (_dl_argv[1], "--argv0") && _dl_argc > 2)
+	  {
+	    argv0 = _dl_argv[2];
+
+	    _dl_skip_args += 2;
+	    _dl_argc -= 2;
+	    _dl_argv += 2;
+	  }
 	else
 	  break;
 
@@ -878,7 +888,8 @@ of this helper program; chances are you did not intend to run this program.\n\
 			variable LD_LIBRARY_PATH\n\
   --inhibit-rpath LIST  ignore RUNPATH and RPATH information in object names\n\
 			in LIST\n\
-  --audit LIST          use objects named in LIST as auditors\n");
+  --audit LIST          use objects named in LIST as auditors\n\
+  --argv0 STRING        set argv[0] to STRING before running\n");
 
       ++_dl_skip_args;
       --_dl_argc;
@@ -971,6 +982,10 @@ of this helper program; chances are you did not intend to run this program.\n\
 	    break;
 	  }
 #endif
+
+      /* Set the argv[0] string now that we've processed the executable.  */
+      if (argv0 != NULL)
+	_dl_argv[0] = argv0;
     }
   else
     {
-- 
2.7.4



^ permalink raw reply related	[flat|nested] 22+ messages in thread

end of thread, other threads:[~2020-09-29 10:37 UTC | newest]

Thread overview: 22+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2020-08-12 11:06 [PATCH] ld.so: add an --argv0 option Vincent Mihalkovic via Libc-alpha
2020-08-25 15:10 ` Adhemerval Zanella via Libc-alpha
2020-08-26 11:53   ` [PATCH v2] " vmihalko--- via Libc-alpha
2020-08-26 13:55     ` Adhemerval Zanella via Libc-alpha
2020-08-31 13:22       ` [PATCH v3] " vincent via Libc-alpha
2020-09-01 15:09         ` Adhemerval Zanella via Libc-alpha
2020-09-14 14:17           ` [PATCH v4] " vincent via Libc-alpha
2020-09-14 15:03             ` Andreas Schwab
2020-09-14 21:32               ` [PATCH v5] " vincent via Libc-alpha
2020-09-23  6:06                 ` vincent via Libc-alpha
2020-09-24  9:53                   ` Florian Weimer via Libc-alpha
2020-09-24 12:43                     ` [PATCH v6] " vincent via Libc-alpha
2020-09-29  8:21                     ` vincent via Libc-alpha
2020-09-29 10:37                       ` Florian Weimer via Libc-alpha
  -- strict thread matches above, loose matches on Subject: below --
2020-07-22  8:33 [PATCH] " Vincent Mihalkovic via Libc-alpha
2020-07-22  9:00 ` Florian Weimer via Libc-alpha
2020-07-26 20:00   ` Vincent Mihalkovic via Libc-alpha
2020-07-27  5:54     ` Florian Weimer via Libc-alpha
2016-04-23  5:28 Mike Frysinger
2016-04-23 12:21 ` Florian Weimer
2016-04-23 20:06   ` Mike Frysinger
2016-04-24 12:21     ` Florian Weimer

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).